﻿<!--!<#@ template language="C#" #>!-->
<!--!<#@ samplevars Processor="DirectiveProcessor" #>!-->
<!--!<# if (!Params.AddCustomGetHandler) return string.Empty; #>!-->
<!--!<# if (Params.Hosting == HostingEnvironment.IIS) { #>!-->
<%@ Page Title="WebDAV" Language="C#" AutoEventWireup="true"%>
<!--!<# } #>!-->
<!DOCTYPE html>
<html lang="en">
  <head>
    <title>IT Hit Ajax File Browser</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />

    <style type='text/css'>
        html, body { margin: 0px; padding: 0px; width: 100%; height: 100%; }
    </style>
    <!--
	    JavaScript file, styles and images required to run Ajax File Browser are loaded from IT Hit website. 
	    To load files from your website download them here: https://www.webdavsystem.com/ajaxfilebrowser/download, 
	    deploy them to your website and replace the 'https://www.ajaxbrowser.com/ITHitService/' path in this file.
    -->
    <script src="https://www.ajaxbrowser.com/ITHitService/AjaxFileBrowser/ITHitAJAXFileBrowserLoader.js" type="text/javascript"></script>
	<script type="text/javascript">

	    // This function creates Ajax File Browser
	    function InitAjaxFileBrowser() {

	        var webDavFolderUrl = window.opener != null ? window.opener.webDavFolderUrl : '/';
	        var selectedFolder = window.opener != null ? window.opener.location.href.replace(window.opener.location.hash, '') : '/';

	        // Customize the look of Ajax File Browser below
	        // http://www.webdavsystem.com/ajaxfilebrowser/programming/settings_reference
	        var settings = {
	            BasePath: 'https://www.ajaxbrowser.com/ITHitService/AjaxFileBrowser/',   // (required) path to ajax file browser files (this folder contains ITHitAJAXFileBrowser.js)
	            Id: 'AjaxFileBrowserContainer',                                         // (required) ID of the HTML control in which Ajax File Browser will be created
	            Url: webDavFolderUrl,                                                   // (required) the root folder to be displyed in Ajax File browser
	            Style: 'height: 100%; width: 100%',                                     // (required) always provide size of the control
	            MsOfficeTemplatesPath: webDavFolderUrl + 'Templates/',   // path to MS Office templates, always specify full path including domain: http://server/path/
	            SelectedFolder: selectedFolder,                          // folder to be selected, same as SetSelectedFolderAsync call
	            ThemeName: 'windows_8',                                  // theme name (folder name under /themes/ folder: 'clean', 'golden', etc), see themes here: http://ajaxbrowser.com/?themesdemo
	            IconsSize: 16,                                           // icon size: 16, 24, 32, 48, 64, 72
	            Platform: 'auto',                                        // show either desktop or mobile UI: 'desktop', 'tablet', 'mobile', 'auto'
	            ShowFolders: true,                                       // show/hide folders in Files View panel
	            ViewModeDesktop: 'details',                              // view mode for desktop UI: 'details', 'medium', 'large', 'extralarge'
	            ViewModeMobile: 'list',                                  // view mode for mobile UI: 'list', 'content', 'thumbnail'
	            EditModeMobile: 'auto',                                  // show bottom menu in mobile UI: 'auto', 'edit', 'view'
	            ShowImagePreview: true,                                  // show thumbnail for images
	            ImageTypes: 'png|jpg|jpeg|gif',                          // show thumbnails for these image types
	            SearchAutocompleteEnable: true,                          // enable auto-complete in search field
	            SearchDynamicEnable: true,                               // update search results list while typing
	            NotAllowedCharacters: '\/:*?"<>|',                       // the list of characters that file and folder names can not contain
	            ProgressRefreshTime: 5,                                  // progress refresh time for IE 9 and earlier
	            EnableHistoryNavigation: true,                           // use Back and Forward web browser buttons to navigate through history
	            OpenHistoryLink: true,                                   // navigate to path specified in url hash
	            ShowContextHelp: true,                                   // show description in icons view, for toolbar buttons and context menus

	            // The block below is used when opening documents from server with pure cookies authentication. Not required for challenge-response auth (Basic/Digest/NTLM/Kerberos).
	            //!<# if (Params.AuthenticationType.HasFlag(AuthenticationType.Cookies)) { #>
	            EditDocAuth: {
	                Authentication: 'cookies',                           // Authentication to use when opening documents for editing: 'challenge', 'cookies'
	                SearchIn: 'current',                                 // Web browsers to search and copy permanent cookies from: 'сurrent', 'none'.
                    //!<# if (Params.IsOwinAuthMode || Params.Hosting == HostingEnvironment.NetCore) { #>
                    CookieNames: '.AspNet.ApplicationCookie',            // Coma separated list of cookie names to search for.
                    //!<# } else { #>
                    CookieNames: '.ASPXAUTH',                            // Coma separated list of cookie names to search for.
                    //!<# } #>
	                LoginUrl: '/Account/login/'                          // Login URL to redirect to in case any cookies specified in CookieNames parameter are not found.
	            },

	            //!<# } else { #>
	            // EditDocAuth: {
	            //    Authentication: 'cookies',                           // Authentication to use when opening documents for editing: 'challenge', 'cookies'
	            //    SearchIn: 'current',                                 // Web browsers to search and copy permanent cookies from: 'сurrent', 'none'.
	            //    CookieNames: '.AspNet.ApplicationCookie',            // Coma separated list of cookie names to search for.
	            //    LoginUrl: '/Account/login/'                          // Login URL to redirect to in case any cookies specified in CookieNames parameter are not found.
	            //},

	            //!<# } #>
	            Panels: {
	                Toolbar: { Show: true },
	                AddressBar: { Show: true },
	                Folders: { Show: true },
	                //!<# if (Params.CalDav || Params.CardDav) { #>
	                UploadPanel: { Show: false },
	                //!<# } else { #>
	                UploadPanel: { Show: true },
	                //!<# } #>
	                FilesView: {
	                    Show: true,
	                    Order: ['Icon', 'Name', 'Size', 'Type', 'DateModified'],
	                    Columns: [
                            {
                                Id: 'Icon',
                                Show: true
                            },
                            {
                                Id: 'Name',
                                //Text: 'My Caption',
                                //Tooltip: 'My Tooltip',
                                //CellStyles: { textAlign: 'right', color: 'blue', fontWeight: 'bold' },
                                //HeaderStyles: { textAlign: 'right' },
                                Width: '300px'
                            },
                            {
                                Id: 'Size',
                                //!<# if (Params.CalDav || Params.CardDav) { #>
                                Show: false,
                                //!<# } else { #>
                                Show: true
                                //!<# } #>
                            },
                            {
                                Id: 'Type',
                                Show: true
                            },
                            {
                                Id: 'DateModified',
                                //!<# if (Params.CalDav || Params.CardDav) { #>
                                Show: false,
                                //!<# } else { #>
                                Show: true
                                //!<# } #>
                            }
                        ]
	                },
	                UploadProgressPanel: {
	                    //!<# if (Params.CalDav || Params.CardDav) { #>
	                    Show: false,
	                    //!<# } else { #>
	                    Show: true,
	                    //!<# } #>
                        Order: ['Icon', 'Source', 'Destination'],
                        Columns: [
                        {
                            Id: 'Icon',
                            Show: true
                        },
                        {
                            Id: 'Source',
                            Show: false
                        },
                        {
                            Id: 'Destination',
                            //Width: 'auto'
                            Show: true
                        },
                        {
                            Id: 'ProgressBar',
                            Show: true,
                            Width: '180px'
                        },
                        {
                            Id: 'Progress',
                            Show: true
                        },
                        {
                            Id: 'Uploaded',
                            Show: true
                        },
                        {
                            Id: 'FileSize',
                            Show: true
                        },
                        {
                            Id: 'Speed',
                            Show: true
                        },
                        {
                            Id: 'TimeLeft',
                            Show: true,
                            Noresize: 'true'
                        },
                        {
                            Id: 'TimeElapsed',
                            Show: true
                        }
                        ]
                    }
                }
            };

	        var ajaxFileBrowserLoader = new ITHit.WebDAV.Client.AjaxFileBrowserLoader(settings);
	        ajaxFileBrowserLoader.oninit = function (ajaxFileBrowser) {
	            // This event is fired when control is loaded and created.
	            // Your code here... 
	        };
	        ajaxFileBrowserLoader.LoadAsync();   // starts loading Ajax File Browser files asynchronously
	    }
	</script>
  </head>
  <body onload="InitAjaxFileBrowser()">
    <div id="AjaxFileBrowserContainer" class="ih_style" style="width: 100%; height: 100%"></div>        
  </body>
</html>
