let sliceLastSymbol = function(str, symbol) {
  var strVal = str;
  if (strVal) {
    var lastChar = strVal.slice(-1);
    if (lastChar == symbol) {
      strVal = strVal.slice(0, -1);
    }
  }
  return strVal;
};

let getWebsiteRootUrl = function(url) {
  if (url && url[0] == "/") {
    return window.location.origin + sliceLastSymbol(url, "/");
  }

  return sliceLastSymbol(url, "/");
};
export default {
  WebDavServerPath:
    window.webDavSettings && window.webDavSettings.WebDavServerPath
      ? getWebsiteRootUrl(window.webDavSettings.WebDavServerPath)
      : "",
  WebDavServerVersion:
    window.webDavSettings && window.webDavSettings.WebDavServerVersion
      ? window.webDavSettings.WebDavServerVersion
      : "",
  WebSocketPath:
    window.webDavSettings && window.webDavSettings.WebSocketPath
      ? window.webDavSettings.WebSocketPath
      : "",
  ApplicationProtocolsPath:
    window.webDavSettings && window.webDavSettings.ApplicationProtocolsPath
      ? window.webDavSettings.ApplicationProtocolsPath
      : "/js/node_modules/webdav.client/Plugins/",
  EditDocAuth: {
    Authentication:
      window.webDavSettings && window.webDavSettings.Authentication
        ? window.webDavSettings.Authentication
        : "anonymous", // Authentication to use when opening documents for editing: 'anonymous', 'challenge', 'ms-ofba', 'cookies'
    CookieNames:
      window.webDavSettings && window.webDavSettings.CookieNames
        ? window.webDavSettings.CookieNames
        : null, // Coma separated list of cookie names to search for.
    SearchIn:
      window.webDavSettings && window.webDavSettings.SearchIn
        ? window.webDavSettings.SearchIn
        : null, // Web browsers to search and copy permanent cookies from: 'current', 'none', 'all'.
    LoginUrl:
      window.webDavSettings && window.webDavSettings.LoginUrl
        ? window.webDavSettings.LoginUrl
        : null // Login URL to redirect to in case any cookies specified in CookieNames parameter are not found.
  }
};
