import Vue from "vue";
import App from "@/App.vue";
import router from "@/router";
import { WebDavStore } from "@/stores/WebDavStore.js";
import i18n from "@/i18n";
import { ITHit } from "webdav.client";

import "@/directives/focus.js";
import "@/directives/collapse.js";

if (window.webDavSettings && window.webDavSettings.LicenseId) {
  ITHit.WebDAV.Client.LicenseId = window.webDavSettings.LicenseId;
}

Vue.config.productionTip = false;

new Vue({
  router,
  store: WebDavStore,
  i18n,
  render: h => h(App)
}).$mount("#app");
