export class HierarchyItem {
  DisplayName = "";
  IsFolder;
  Href;
  Host;
  ContentLength = 0;
  LastModified;
  Properties;
  ActiveLocks;
  DeleteAsync;
  MoveToAsync;
  CopyToAsync;
  constructor(oItem) {
    this.DisplayName = oItem.DisplayName;
    this.IsFolder = oItem.IsFolder();
    this.Href = oItem.Href;
    this.Host = oItem.Host;
    this.ContentLength = oItem.ContentLength;
    this.LastModified = oItem.LastModified;
    this.Properties = oItem.Properties;
    this.ActiveLocks = oItem.ActiveLocks;
    this.DeleteAsync = () =>
      new Promise((resolve, reject) => {
        oItem.DeleteAsync(null, data => {
          if (!data.IsSuccess) return reject(data);
          resolve(data);
        });
      });
    this.MoveToAsync = (currentFolder, itemName) =>
      new Promise((resolve, reject) => {
        oItem.MoveToAsync(
          currentFolder,
          itemName ? itemName : oItem.DisplayName,
          null,
          null,
          data => {
            if (!data.IsSuccess) return reject(data);
            resolve(data);
          }
        );
      });
    this.CopyToAsync = (currentFolder, itemName) =>
      new Promise((resolve, reject) => {
        oItem.CopyToAsync(currentFolder, itemName, true, null, null, data => {
          if (!data.IsSuccess) return reject(data);
          resolve(data);
        });
      });
  }
}
