import Vue from "vue";
import Router from "vue-router";
import Main from "@/components/Main.vue";
import { WebDavStore } from "@/stores/WebDavStore.js";
import UrlResolveService from "@/services/UrlResolveService.js";
Vue.use(Router);
const routes = [
  {
    name: "main",
    path: "/:catchAll(.*)",
    component: Main
  }
];

const router = new Router({
  linkActiveClass: "active",
  linkExactActiveClass: "exact-active",
  mode: "history",
  routes
});
router.beforeEach(function(to, from, next) {
  if (to.path != WebDavStore.state.grid.CurrentUrl) {
    WebDavStore.commit("setCurrentUrl", to.path);
    WebDavStore.commit("setSearchQuery", "");
  }
  UrlResolveService.setHashObject(to.hash);
  WebDavStore.commit("updateGrid");
  next();
});
export default router;
