import { WebDavProtocolItem } from "@/models/WebDavProtocolItem.js";
import webDavSettings from "@/WebDavSettings.js";
import i18n from "@/i18n";

export const AllOs = [
  new WebDavProtocolItem(
    "Windows:&nbsp;&nbsp;",
    webDavSettings.ApplicationProtocolsPath + "ITHitEditDocumentOpener.msi",
    "ITHitEditDocumentOpener.msi",
    "window"
  ),
  new WebDavProtocolItem(
    "Linux:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",
    webDavSettings.ApplicationProtocolsPath + "ITHitEditDocumentOpener.deb",
    "ITHitEditDocumentOpener.deb",
    "linux"
  ),
  new WebDavProtocolItem(
    "Mac OS:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",
    webDavSettings.ApplicationProtocolsPath + "ITHitEditDocumentOpener.pkg",
    "ITHitEditDocumentOpener.pkg",
    "mac-os"
  )
];

export const AllBrowsers = [
  new WebDavProtocolItem(
    "",
    "https://chrome.google.com/webstore/detail/it-hit-edit-doc-opener-5/nakgflbblpkdafokdokmjdfglijajhlp",
    i18n.t("phrases.extensionFor", { browser: "Google Chrome." }),
    "goole-chrome"
  ),
  new WebDavProtocolItem(
    "",
    "https://addons.mozilla.org/en-CA/firefox/addon/it-hit-edit-doc-opener-5/",
    i18n.t("phrases.extensionFor", { browser: "Mozilla Firefox." }),
    "mozilla-firefox"
  ),
  new WebDavProtocolItem(
    "",
    "https://microsoftedge.microsoft.com/addons/detail/mdfaonmaoigngflemfmkboffllkopopm",
    i18n.t("phrases.extensionFor", { browser: "Microsoft Edge Chromium." }),
    "edge-chromium"
  )
];
