const { defineConfig } = require("@vue/cli-service");
const webpack = require("webpack");
module.exports = defineConfig({
  filenameHashing: false,
  outputDir: "../wwwroot",
  chainWebpack: config => {
    config.optimization.delete("splitChunks");
  },
  configureWebpack: {
    output: {
      filename: "app.js"
    },
    plugins: [
      new webpack.IgnorePlugin({
        resourceRegExp: /^\.\/locale$/,
        contextRegExp: /moment$/
      })
    ]
  },
  pluginOptions: {
    i18n: {
      locale: "en",
      fallbackLocale: "en",
      localeDir: "locales",
      enableInSFC: false
    }
  },

  css: {
    extract: {
      filename: "app.css"
    },
    loaderOptions: {
      css: {
        url: false
      },
      scss: {
        prependData: process.env.VUE_APP_IMAGES_PATH
          ? "$image-base-path: " +
            JSON.stringify(process.env.VUE_APP_IMAGES_PATH) +
            ";"
          : ""
      }
    }
  }
});
