﻿<!--!<#@ template language="C#" #>!-->
<!--!<#@ samplevars Processor="DirectiveProcessor" #>!-->
<!--!<# if (!Params.AddCustomGetHandler || Params.CalDav || Params.CardDav)  return string.Empty; #>!-->
<!--!<# if (Params.Hosting == HostingEnvironment.IIS) { #>!-->

<%@ Page Async="true" Title="WebDAV" Language="C#" AutoEventWireup="true" Inherits="ITHit.WebDav.Server.SampleModel.MyCustomHandlerPage" %>

<%@ Import Namespace="ITHit.WebDAV.Server.Class1" %>
<!--!<# } #>!-->
<!DOCTYPE html>
<html lang="en">
<head>
    <title>IT Hit WebDAV Server Engine</title>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=0, minimum-scale=1.0, maximum-scale=1.0">
    <link href="<%=Request.ApplicationPath.TrimEnd('/')%><#=Params.WWWRootUrlPath #>/app.css" rel="stylesheet" />
    <link rel="icon" href="<%=Request.ApplicationPath.TrimEnd('/')%><#=Params.WWWRootUrlPath #>/favicon.ico" />
</head>
<body>
    <main role="main">
        <div id="app" data-template="<%=Request.ApplicationPath.TrimEnd('/')%><#=Params.WWWRootUrlPath #>/app.html"></div>
    </main>
    <script>
        var webDavSettings = {
            // IT Hit WebDAV Ajax Library activation info:
            // https://www.webdavsystem.com/ajax/programming/activating/
            // - The trial version is fully functional and does not have any limitations, however it is time-limited and will stop working when the trial period expires.
            // - In case you have a perpetual license, replace the JavaScript file(s) with the file(s) from the non-trial version. Download the non-trial version in the product download area.
            // - In case of a subscription license set the License ID in JavaScript. Get the License ID in the product download area:
            //LicenseId: 'XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX',
            //!<# if (string.IsNullOrEmpty(Params.DavUrlPrefix)) { #>
            WebDavServerPath: '<%=Request.ApplicationPath.TrimEnd('/')%>',
            //!<# } else { #>
            WebDavServerPath: '<%=Request.ApplicationPath.TrimEnd('/')%>/&lt;#=Params.DavUrlPrefix.Trim('/')#>',
            //!<# } #>
            ApplicationProtocolsPath: '<%=Request.ApplicationPath.TrimEnd('/')%><#=Params.WWWRootUrlPath #>/webdav.client/Plugins/',
            //!<# if (Params.AuthenticationType.HasFlag(AuthenticationType.Cookies)) { #>
            EditDocAuth: {
                Authentication: '&lt;#=Params.AuthenticationType.HasFlag(AuthenticationType.Msofba)?"ms-ofba":"cookies"#>',// Authentication to use when opening documents for editing: 'anonymous', 'challenge', 'ms-ofba', 'cookies'
                //!<# if (Params.IsOwinAuthMode) { #>
                CookieNames: '.AspNet.ApplicationCookie',                                                                  // Coma separated list of cookie names to search for.
                //!<# } else if (Params.Hosting == HostingEnvironment.NetCore) { #>
                CookieNames: '_webDavAuthCookieNames_',                                                                    // Coma separated list of cookie names to search for.
                //!<# } else { #>
                CookieNames: '.ASPXAUTH',                                                                                  // Coma separated list of cookie names to search for.
                //!<# } #>
                SearchIn: 'current',                                                                                       // Web browsers to search and copy permanent cookies from: 'current', 'none'.
                LoginUrl: '/Account/login/'                                                                                // Login URL to redirect to in case any cookies specified in CookieNames parameter are not found.
            },
            //!<# } else { #>
			EditDocAuth: {
                Authentication: '&lt;#=Params.AuthenticationType == AuthenticationType.None?"anonymous":(Params.AuthenticationType.HasFlag(AuthenticationType.Msofba)?"ms-ofba":"challenge")#>',                       // Authentication to use when opening documents for editing: 'anonymous', 'challenge', 'ms-ofba', 'cookies'
                CookieNames: null,                                 // Coma separated list of cookie names to search for.
                SearchIn: null,                                    // Web browsers to search and copy permanent cookies from: 'current', 'none'.
                LoginUrl: null                                     // Login URL to redirect to in case any cookies specified in CookieNames parameter are not found.
            },
            //!<# } #>
            //!<# if (Params.Hosting == HostingEnvironment.IIS) { #>
            WebDavServerVersion: 'v<%=System.Reflection.Assembly.GetAssembly(typeof(ITHit.WebDAV.Server.DavEngineAsync)).GetName().Version%>'
            //!<# } else { #>
            WebDavServerVersion: 'v_webDavServerVersion_'
            //!<# } #>
        }

        function OpenAjaxFileBrowserWindow() {
            //!<# if (Params.Hosting == HostingEnvironment.IIS) { #>
            window.open("<%=Request.ApplicationPath.TrimEnd('/')%>/AjaxFileBrowser/AjaxFileBrowser.aspx", "", "menubar=1,location=1,status=1,scrollbars=1,resizable=1,width=900,height=600");
            //!<# } else { #>
            window.open("/AjaxFileBrowser/AjaxFileBrowser.html", "", "menubar=1,location=1,status=1,scrollbars=1,resizable=1,width=900,height=600");
            //!<# } #>
        }

        function OpenTestsWindow() {
            var width = Math.round(screen.width * 0.5);
            var height = Math.round(screen.height * 0.8);
            //!<# if (!string.IsNullOrEmpty(Params.DavUrlPrefix)) { #>
            window.open("<%=Request.ApplicationPath.TrimEnd('/')%>/AjaxFileBrowser/AjaxIntegrationTests.aspx#" + window.location.origin + "/<#=Params.DavUrlPrefix.Trim('/')#>", "", "menubar=1,location=1,status=1,scrollbars=1,resizable=1,width=" + width + ",height=" + height);
            //!<# } else if (Params.Hosting == HostingEnvironment.IIS) { #>
            window.open("<%=Request.ApplicationPath.TrimEnd('/')%>/AjaxFileBrowser/AjaxIntegrationTests.aspx", "", "menubar=1,location=1,status=1,scrollbars=1,resizable=1,width=" + width + ",height=" + height);
            //!<# } else { #>
            window.open("/AjaxFileBrowser/AjaxIntegrationTests.html", "", "menubar=1,location=1,status=1,scrollbars=1,resizable=1,width=" + width + ",height=" + height);
            //!<# } #>
        }
    </script>
    <!--
    JavaScript file required to run WebDAV Ajax library is loaded from Node.js Package Manager.
    To load files from your website download them here: https://www.webdavsystem.com/ajax/download,
    deploy them to your website and replace the path below in this file.
    -->
    <script src="<%=Request.ApplicationPath.TrimEnd('/')%><#=Params.WWWRootUrlPath #>/app.js"></script>
</body>
</html>
