//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (!Params.AddCustomGetHandler || (Params.Hosting != HostingEnvironment.IIS))  return string.Empty; #>

using System;
using System.Linq;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Threading.Tasks;

using ITHit.WebDAV.Server;
//!<# if (Params.CalDav) { #>
using ITHit.WebDAV.Server.CalDav;
//!<# } #>
//!<# if (Params.CardDav) { #>
using ITHit.WebDAV.Server.CardDav;
//!<# } #>
//!<# if (false) { #>
// only required to compile project at dev time
using ITHit.WebDav.Server.SampleModel.__NtfsStorage__;
//!<# } #>

namespace ITHit.WebDav.Server.SampleModel
{
    public class MyCustomHandlerPage : Page
    {
        protected MyCustomHandlerPage()
        {
            if (Type.GetType("Mono.Runtime") == null)
            {
                this.Load += Page_LoadAsync;
            }
        }

        void Page_LoadAsync(object sender, EventArgs e)
        {
            //!<# if (Params.TargetFramework45OrLater) { #>
            RegisterAsyncTask(new PageAsyncTask(GetPageDataAsync));
            //!<# } else { #>
            GetPageData();
            //!<# } #>
        }

        public async Task GetPageDataAsync()
        {
            //!<# if (Params.CalDav || Params.CardDav) { #>
            //!<# if (Params.Storage == StorageType.Db) { #>
            using (DavContext context = new DavContext(HttpContext.Current))
            {
            //!<# } else { #>
                DavContext context = new DavContext(HttpContext.Current);
            //!<# } #>

                Discovery discovery = new Discovery(context);

                //!<# if (Params.CalDav) { #>

                // Get all user calendars Urls.
                // Get list of folders that contain user calendars and enumerate calendars in each folder.
                foreach (IItemCollection folder in await discovery.GetCalendarHomeSetAsync())
                {
                    IEnumerable<IHierarchyItem> children = (await folder.GetChildrenAsync(new PropertyName[0], null, null, null)).Page;
                    AllUserCalendars.AddRange(children.Where(x => x is ICalendarFolder));
                }
                //!<# } #>
                //!<# if (Params.CardDav) { #>

                // Get all user address books Urls.
                // Get list of folders that contain user address books and enumerate address books in each folder.
                foreach (IItemCollection folder in await discovery.GetAddressbookHomeSetAsync())
                {
                    IEnumerable<IHierarchyItem> children = (await folder.GetChildrenAsync(new PropertyName[0], null, null, null)).Page;
                    AllUserAddressbooks.AddRange(children.Where(x => x is IAddressbookFolder));
                }
                //!<# } #>
            //!<# if (Params.Storage == StorageType.Db) { #>
            }
            //!<# } #>
            //!<# } #>
        }
        
        //!<# if (Params.CalDav) { #>

        /// <summary>
        /// Gets all user calendars.
        /// </summary>
        public List<IHierarchyItem> AllUserCalendars = new List<IHierarchyItem>();
        //!<# } #>
        //!<# if (Params.CardDav) { #>

        /// <summary>
        /// Gets all user address books.
        /// </summary>
        public List<IHierarchyItem> AllUserAddressbooks = new List<IHierarchyItem>();
        //!<# } #>
        //!<# if (Params.CalDav || Params.CardDav) { #>

        public static string ApplicationPath
        {
            get
            {
                //!<# if (Params.Storage == StorageType.Db) { #>
                using (DavContext context = new DavContext(HttpContext.Current))
                {
                //!<# } else { #>
                    DavContext context = new DavContext(HttpContext.Current);
                //!<# } #>
                    Uri url = HttpContext.Current.Request.Url;
                    string server = url.Scheme + "://" + url.Host + (url.IsDefaultPort ? "" : ":" + url.Port.ToString()) + "/" + context.Request.ApplicationPath.Trim('/');
                    return server.TrimEnd('/') + '/';
                //!<# if (Params.Storage == StorageType.Db) { #>
                }
                //!<# } #>
            }
        }
        //!<# } #>
    }
}