//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (Params.Hosting != HostingEnvironment.IIS)  return string.Empty; #>
//!<# if (!Params.AuthenticationType.HasFlag(AuthenticationType.Msofba))  return string.Empty; #>
//!<# if (!Params.IsOwinAuthMode) return string.Empty; #>
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Owin;

namespace ITHit.WebDav.Server.SampleModel.__Authentication__.MSOFBAuthentication
{
    /// <summary>
    /// Provides extension methods to add MS-OFBA Authenticaiton middleware to ASP.NET MVC project
    /// using app.UseXXX() patern.
    /// </summary>
    public static class MSOFBAuthenticationExtensions
    {
        /// <summary>
        /// Adds MS-OFBA authentication middleware to the OWIN project (using passed <see cref="MSOFBAuthenticationOptions"/> class).
        /// </summary>
        public static IAppBuilder UseMicrosoftOfficeFormsBasedAuthentication(this IAppBuilder app, MSOFBAuthenticationOptions options)
        {
            return app.Use<MSOFBAuthenticationMiddleware>(options);
        }

        /// <summary>
        /// Adds MS-OFBA authentication middleware to the OWIN project (using default settings of <see cref="MSOFBAuthenticationOptions"/>).
        /// </summary>
        public static IAppBuilder UseMicrosoftOfficeFormsBasedAuthentication(this IAppBuilder app)
        {
            return app.UseMicrosoftOfficeFormsBasedAuthentication(new MSOFBAuthenticationOptions());
        }
    }
}