//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (!Params.ACL)  return string.Empty; #>
//!<# if (Params.Storage != StorageType.Blank)  return string.Empty; #>
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

using ITHit.WebDAV.Server;
using ITHit.WebDAV.Server.Acl;
using ITHit.WebDAV.Server.Class2;
using ITHit.WebDAV.Server.DeltaV;
using ITHit.WebDAV.Server.Extensibility;
using ITHit.WebDAV.Server.Quota;
using IPrincipal = ITHit.WebDAV.Server.Acl.IPrincipal;

namespace ITHit.WebDav.Server.SampleModel.__DavImpl__
{
    /// <summary>
    /// Represents user group.
    /// </summary>
    public class Group : IPrincipal
    {
        /// <summary>
        /// Initializes a new instance of the Group class.
        /// </summary>
        /// <param name="context">Instance of <see cref="DavContext"/> class.</param>
        public Group(DavContext context)
        {
        }

        /// <summary>
        /// Replaces members of the group to be those specified in <paramref name="members"/> parameter.
        /// </summary>
        /// <param name="members">New member(user or groups) list.</param>
        public async Task SetGroupMembersAsync(IList<IPrincipal> members)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Retrieves principals that are direct members of this group. Since a group
        /// may be a member of another group, a group may also have indirect members (i.e., the members of its direct
        /// members). 
        /// </summary>
        /// <returns>Members of the group identified by this principal.</returns>
        public async Task<IEnumerable<IPrincipal>> GetGroupMembersAsync()
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Determines whether the principal is well known, the one that is defined by
        /// <see cref="WellKnownPrincipal"/> enumeration.
        /// </summary>
        /// <param name="wellknownPrincipal">Type of wellknown principal to check this one against.</param>
        /// <returns>Whether the principal is <paramref name="wellknownPrincipal"/>.</returns>
        public bool IsWellKnownPrincipal(WellKnownPrincipal wellknownPrincipal)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Identifies the groups in which the principal is directly a member. Note that a server may
        /// allow a group to be a member of another group, in which case the <see cref="IPrincipal.GetGroupMembershipAsync"/>
        /// of those other groups would need to be queried in order to determine the groups in which the principal
        /// is indirectly a member.
        /// </summary>
        /// <returns>Returns group this principal belongs to.</returns>
        public async Task<IEnumerable<IPrincipal>> GetGroupMembershipAsync()
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the name of the item in repository.
        /// </summary>
        public string Name
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Gets the creation date of the item in repository expressed as the coordinated universal time (UTC).
        /// </summary>
        public DateTime Created
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Gets the last modification date of the item in repository expressed as the coordinated universal time (UTC).
        /// </summary>
        public DateTime Modified
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Creates a copy of this item with a new name in the destination folder.
        /// </summary>
        /// <param name="destFolder">Destination folder.</param>
        /// <param name="destName">Name of the destination item.</param>
        /// <param name="deep">Indicates whether to copy entire subtree.</param>
        /// <param name="multistatus">If some items fail to copy but operation in whole shall be continued, add
        /// information about the error into <paramref name="multistatus"/> using 
        /// <see cref="MultistatusException.AddInnerException(string,ITHit.WebDAV.Server.DavException)"/>.
        /// </param>
        /// <remarks>
        /// <para>
        /// If error occurred while copying file located in a subtree, the server 
        /// should try to continue copy operation and copy all other items. In this case 
        /// you must add that error <paramref name="multistatus"/> container.
        /// </para>
        /// <para>
        /// A CopyTo method invocation must not copy any locks active on the source item.
        /// However, if this method copies the item into a folder that has a deep lock,
        /// then the destination item must be added to the lock.
        /// </para>
        /// </remarks>
        public async Task CopyToAsync(IItemCollection destFolder, string destName, bool deep, MultistatusException multistatus)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Moves this item to the destination folder under a new name.
        /// </summary>
        /// <param name="destFolder">Destination folder.</param>
        /// <param name="destName">Name of the destination item.</param>
        /// <param name="multistatus">If some items fail to copy but operation in whole shall be continued, add
        /// information about the error into <paramref name="multistatus"/> using 
        /// <see cref="MultistatusException.AddInnerException(string,ITHit.WebDAV.Server.DavException)"/>.
        /// </param>
        /// <remarks>
        /// <papa>
        /// If the item is locked the server must not move any locks with the item. However, items must be added to an
        /// existing lock at the destination.
        /// </papa>
        /// </remarks>
        public async Task MoveToAsync(IItemCollection destFolder, string destName, MultistatusException multistatus)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Deletes this item.
        /// </summary>
        /// <param name="multistatus">If some items fail to delete but operation in whole shall be continued, add
        /// information about the error into <paramref name="multistatus"/> using
        /// <see cref="MultistatusException.AddInnerException(string,ITHit.WebDAV.Server.DavException)"/>.
        /// </param>
        public async Task DeleteAsync(MultistatusException multistatus)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets values of all properties or selected properties for this item.
        /// </summary>
        /// <param name="props">
        /// Array of property names which values are requested. 
        /// If a property does not exist for this hierarchy item then the property value shall not be returned.
        /// </param>
        /// <param name="allprop">
        /// If it is <c>true</c> it means that besides properties listed in <paramref name="props"/> you need to 
        /// return all properties you think may be useful to client.
        /// </param>
        /// <returns>
        /// Enumerable with property values.
        /// </returns>
        public async Task<IEnumerable<PropertyValue>> GetPropertiesAsync(IList<PropertyName> props, bool allprop)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets names of all properties for this item.
        /// </summary>
        /// <returns>
        /// Enumerable with available property names.
        /// </returns>
        /// <remarks>
        /// <para>Most WebDAV clients never request list of property names, so your implementation can just return
        /// empty enumerable.</para>
        /// </remarks>
        public async Task<IEnumerable<PropertyName>> GetPropertyNamesAsync()
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Modifies and removes properties for this item.
        /// </summary>
        /// <param name="setProps">Array of properties to be set.</param>
        /// <param name="delProps">
        /// Property names to be removed. Properties that don't exist shall be skipped.
        /// </param>
        /// <param name="multistatus">The standard requires this operation to be transactional.
        /// If some properties fail to update but there is no possibility to rollback the transaction
        /// in <see cref="ContextAsync{IHierarchyItem}.BeforeResponseAsync"/>, add
        /// information about the error into <paramref name="multistatus"/> 
        /// using <see cref="MultistatusException.AddInnerException(string,ITHit.WebDAV.Server.PropertyName,ITHit.WebDAV.Server.DavException)"/>.
        /// In this case engine will report correct statuses for all properties at least
        /// (although this is against standard).
        /// </param>
        public async Task UpdatePropertiesAsync(
            IList<PropertyValue> setProps,
            IList<PropertyName> delProps,
            MultistatusException multistatus)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Unique item path in the repository relative to storage root.
        /// </summary>
        /// <remarks>
        /// <para>
        /// The URL returned by this property is relative to storage root.
        /// If your server root is located at http://example.webdavsystem.com:8080/myserver/ and the item URL is
        /// http://example.webdavsystem.com:8080/myserver/myfolder/myitem.doc this property implementation must
        /// return myfolder/myitem.doc. To calculate the entire item URL the engine will
        /// call <see cref="DavRequest.ApplicationPath"/> property and attach it to url returned by
        /// <see cref="IHierarchyItem.Path"/> property.
        /// </para>
        /// <para>
        /// Every part of the path (between '/' characters) shall be encoded,
        /// for example using <see cref="EncodeUtil"/>.
        /// </para>
        /// <para>Examples:
        /// <list type="bullet">
        /// <item><description>File: myfolder/my%20doc.docx</description></item>
        /// <item><description>Folder: myfolder/folder/</description></item>
        /// <item><description>History item: myfolder/mydoc.docx?history</description></item>
        /// <item><description>Version: myfolder/mydoc.docx?version=5</description></item>
        /// </list>
        /// </para>
        /// </remarks>
        /// <value><c>String</c> representing relative item path in the repository.</value>
        public string Path
        {
            get { throw new NotImplementedException(); }
        }
    }
}
