//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (!Params.ACL)  return string.Empty; #>
//!<# if (Params.Storage != StorageType.Blank)  return string.Empty; #>
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

using ITHit.WebDAV.Server;
using ITHit.WebDAV.Server.Acl;
using ITHit.WebDAV.Server.Paging;
using IPrincipal = ITHit.WebDAV.Server.Acl.IPrincipal;

namespace ITHit.WebDav.Server.SampleModel.__DavImpl__
{
    /// <summary>
    /// Logical folder with path 'acl/groups' which contains groups.
    /// </summary>
    public class GroupFolder : LogicalFolder, IPrincipalFolder
    {
        /// <summary>
        /// Path to folder which contains groups.
        /// </summary>
        public static string PREFIX = "acl/groups";

        /// <summary>
        /// Gets path of folder which contains groups.
        /// </summary>
        public static string PATH
        {
            get { return PREFIX + "/"; }
        }

        /// <summary>
        /// Initializes a new instance of the GroupFolder class.
        /// </summary>
        /// <param name="context">Instance of <see cref="DavContext"/> class.</param>
        public GroupFolder(DavContext context) : base(context, "groups", PATH)
        {
        }

        public override async Task<PageResults> GetChildrenAsync(IList<PropertyName> propNames, long? offset, long? nResults, IList<OrderProperty> orderProps)
        {
            throw new NotImplementedException();
        }

        public async Task<IPrincipalFolder> CreateFolderAsync(string name)
        {
            throw new NotImplementedException();
        }

        public async Task<IPrincipal> CreatePrincipalAsync(string name)
        {
            throw new NotImplementedException();
        }

        public async Task<IEnumerable<IPrincipal>> FindPrincipalsByPropertyValuesAsync(
            IList<PropertyValue> propValues,
            IList<PropertyName> props)
        {
            throw new NotImplementedException();
        }

        public async Task<IEnumerable<PropertyDescription>> GetPrincipalSearcheablePropertiesAsync()
        {
            throw new NotImplementedException();
        }

        public async Task<IEnumerable<IPrincipal>> GetMatchingPrincipalsAsync(IList<PropertyName> props)
        {
            throw new NotImplementedException();
        }
    }
}
