//!<#@ template language="C#" #>
//!<#@ samplevars Processor="DirectiveProcessor" #>
//!<# if (!Params.DeltaV)  return string.Empty; #>
//!<# if (Params.Storage != StorageType.Blank)  return string.Empty; #>
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

using ITHit.WebDAV.Server;
using ITHit.WebDAV.Server.DeltaV;

namespace ITHit.WebDav.Server.SampleModel.__DavImpl__
{
    /// <summary>
    /// Represents list of versions for the single file.
    /// </summary>
    public class VersionHistory : IHistory
    {
        public VersionHistory(DavContext context)
        {
        }
        
        public async Task<IVersion> GetCurrentVersionAsync()
        {
            throw new NotImplementedException();
        }

        public async Task<IEnumerable<IVersion>> GetVersionSetAsync(IList<PropertyName> propNames)
        {
            throw new NotImplementedException();
        }

        public async Task<IVersion> GetRootVersionAsync()
        {
            throw new NotImplementedException();
        }
                
        public async Task CopyToAsync(IItemCollection destFolder, string destName, bool deep, MultistatusException multistatus)
        {
            throw new DavException("Cannot copy history resource", DavStatus.NOT_ALLOWED);
        }

        public async Task MoveToAsync(IItemCollection destFolder, string destName, MultistatusException multistatus)
        {
            throw new DavException("Cannot move history resource", DavStatus.NOT_ALLOWED);
        }

        public async Task DeleteAsync(MultistatusException multistatus)
        {
            throw new DavException("Cannot delete history resource", DavStatus.NOT_ALLOWED);
        }

        public string Name
        {
            get { throw new DavException("The method or operation is not implemented.", DavStatus.NOT_IMPLEMENTED); }
        }

        public DateTime Created
        {
            get { throw new DavException("The method or operation is not implemented.", DavStatus.NOT_IMPLEMENTED); }
        }

        public DateTime Modified
        {
            get { throw new DavException("The method or operation is not implemented.", DavStatus.NOT_IMPLEMENTED); }
        }

        public async Task<IEnumerable<PropertyValue>> GetPropertiesAsync(IList<PropertyName> names, bool allprop)
        {
            throw new DavException("Cannot get properties of history resource.", DavStatus.NOT_ALLOWED);
        }

        public async Task<IEnumerable<PropertyName>> GetPropertyNamesAsync()
        {
            throw new DavException("Cannot get property names of history resource.", DavStatus.NOT_ALLOWED);
        }

        public async Task UpdatePropertiesAsync(
            IList<PropertyValue> setProps,
            IList<PropertyName> delProps,
            MultistatusException multistatus)
        {
            throw new DavException("Cannot update properties of history resource.", DavStatus.NOT_ALLOWED);
        }

        public string Path
        {
            get { throw new NotImplementedException(); }
        }
    }
}
